﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Public rp As RuntimePermissions
	Public SourceFolder As String
	Public Helper As DownloadHelper
	Public dlman As DownloadManager
	Public dlid As Long
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

	SourceFolder = rp.GetSafeDirDefaultExternal("")
	Helper.Initialize
End Sub
Sub DLManager_DownloadFinished(downloadid As Long)
	Log($"DLManager_DownloadFinished(${downloadid})"$)
	Dim uri As String = dlman.getUriForDownloadedFile(downloadid)
	Log("Uri = "&uri)
	Dim cText As String = File.ReadString("ContentDir", uri)
	cText = cText.Replace("<table border=1>", "<table border=1 bgcolor=F0FFFF>")
	Dim cTxt As String = File.ReadString(SourceFolder, "version.txt")
	cText = "<b>Last Updated: " & cTxt & "</b><br>" & cText
	CallSubDelayed2(download_html,"UpdateHTML",cText)
	'Log(cText)
End Sub
public Sub CreateDownloadrequest()
	dlman.Initialize("DLManager")
	dlid = dlman.enqueue(dlman.CreateDownloadRequest("https://www.dropbox.com/s/31w3ksayw80n6b8/b4xgoodies.html?dl=1","Downloading goodies","...",SourceFolder,"b4xgoodies.html",False,True,False))
	Log($"DownloadID = ${dlid}"$)
End Sub
Sub UpdateVersionFile
	Private cFile As String
	cFile = "version.txt"

	If File.Exists(SourceFolder, cFile) Then
		File.Copy(SourceFolder, cFile, SourceFolder, "last_version.txt")
	End If
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
